unit Viecher1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Menus, ComCtrls, ActnList;

const
  MaxValue : integer = 10;
  OPName : array[0..10] of string = ('ENB','DSB','GO','ROTL','ROTR','EAT','SCAN','SPLIT','JMP','','');
  AnzMutationen : integer = 10;
  minzerf : integer = 0;
  tests : integer= 200;

type
  TCode = array[0..100] of byte;
  Tviech = record
            posx,posy,rich: integer;
            nahrung : integer;
            akt : boolean;
            code : TCode;
            ip : integer;
          end;
  TFeld = array[0..19,0..19] of byte;

  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    panel1: TPanel;
    PaintBox1: TPaintBox;
    Button5: TButton;
    Label2: TLabel;
    Label3: TLabel;
    ListBox1: TListBox;
    MainMenu1: TMainMenu;
    Datei1: TMenuItem;
    Viechladen1: TMenuItem;
    Viechspeichern1: TMenuItem;
    Exit1: TMenuItem;
    Hilfe1: TMenuItem;
    Go1: TMenuItem;
    Neueversuche: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ListBox2: TListBox;
    Label4: TLabel;
    Button2: TButton;
    Button3: TButton;
    Zchten1: TMenuItem;
    Label5: TLabel;
    Button4: TButton;
    StatusBar1: TStatusBar;
    Label6: TLabel;
    Button6: TButton;
    Label7: TLabel;
    NeuerCode1: TMenuItem;
    N0101: TMenuItem;
    N0201: TMenuItem;
    N01001: TMenuItem;
    minimalerZchtungserfolg1: TMenuItem;
    keine1: TMenuItem;
    N101: TMenuItem;
    N201: TMenuItem;
    N501: TMenuItem;
    Anzahldernderungen1: TMenuItem;
    N11: TMenuItem;
    N21: TMenuItem;
    N51: TMenuItem;
    N102: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure go;
    procedure die(x: integer);
    procedure createviech;
    function mutiere(code_: TCode): TCode;
    procedure updatestatus;
    procedure filllistbox(liste: TListBox; code_: TCode);
    function cmp(code1,code2: TCode): boolean;
    function testforgood(code_ :TCode; Tests: integer): integer;
    procedure Button5Click(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure NeuesViech1Click(Sender: TObject);
    procedure Hilfe1Click(Sender: TObject);
    procedure NeueversucheClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Viechladen1Click(Sender: TObject);
    procedure Viechspeichern1Click(Sender: TObject);
    procedure EinSchritt1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Zchten1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure N0101Click(Sender: TObject);
    procedure N0201Click(Sender: TObject);
    procedure N01001Click(Sender: TObject);
    procedure keine1Click(Sender: TObject);
    procedure N101Click(Sender: TObject);
    procedure N201Click(Sender: TObject);
    procedure N501Click(Sender: TObject);
    procedure N11Click(Sender: TObject);
    procedure N21Click(Sender: TObject);
    procedure N51Click(Sender: TObject);
    procedure N102Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    viecher : array[0..9]of Tviech;
    Feld : TFeld;
    mark : integer;
    lmark: integer;
    goodcode : TCode;
    generation : integer;
    autook : boolean;
    ausschuss : integer;
  public
    { Public-Deklarationen }
  end;

var
  Form1: TForm1;
  viechf : Text;
implementation

uses Unit2, Unit3;

{$R *.DFM}

procedure TForm1.filllistbox(liste: TListBox; code_: TCode);
var int2 : integer;
    str1 : string;
begin
  liste.Clear;
  label7.caption := '? Viecher von 100';
  for int2 := 0 to 100 do begin
    str1 := inttostr(int2)+': '+ inttostr(code_[int2])+'  ';
    if code_[int2]< 10 then str1 := str1 + OPName[code_[int2]];
    Liste.Items.Add(str1);
  end;
end;

procedure TForm1.updatestatus;
begin
  if mark <> -1 then begin
    with viecher[mark] do begin
      label3.caption := inttostr(nahrung);
      if (lmark <> mark) or true then begin
        filllistbox(listbox1,code);
        lmark := mark;
      end;
        ListBox1.itemindex := ip;
    end;
  end else begin listbox1.clear; label3.caption := ''; end;
  label5.caption := 'Der '+ inttostr(generation)+'. Generation';
  statusbar1.panels[0].Text:= 'Verendet: '+ inttostr(ausschuss);
end;

procedure TForm1.die(x: integer);
begin
  fillchar(viecher[x],sizeof(viecher[x]),0);
  if mark = x then mark := -1;
  inc(ausschuss);
end;

function TForm1.mutiere(code_: TCode): TCode;
var int1 : integer;
begin
  result := code_;
  for int1 := 1 to AnzMutationen do result[random(101)] := random(maxvalue+1);
end;

procedure TForm1.FormCreate(Sender: TObject);
var int1 : integer;
begin
  ausschuss := 0;
  randomize;
  for int1 := 0 to 9 do viecher[int1].nahrung := 0;
  fillchar(feld,sizeof(feld),0);
  for int1 := 0 to 70 do feld[random(20),random(20)] := 1;
  mark:= -1;
  lmark := -1;
  autook := false;
  createviech;
end;

procedure TForm1.createviech;
var int1 : integer;
begin
  int1 := 0;
  while (viecher[int1].nahrung > 0) and (int1 < 9) do inc(int1);
  if int1 = 10 then exit;
  with viecher[int1] do begin
    posx := random(19);
    posy := random(19);
    rich := random(3);
    code := mutiere(goodcode);
    nahrung := 20;
    ip := 0;
    akt := true;
  end;
  mark := int1;
end;

function TForm1.cmp(code1,code2: TCode): boolean;
var int1 : integer;
begin
  for int1 := 0 to 100 do
    if code1[int1] <> code2[int1] then begin result := false; exit; end;
  result := true;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
var int1,int2: integer;
begin
  with paintbox1 do begin
    canvas.Pen.Width := 1;
    canvas.brush.style:= bsDiagCross;
    canvas.brush.color := clGreen;
    canvas.Pen.Color := ClBlack;
    for int1 := 1 to 19 do begin
      canvas.MoveTo(int1*20,0);
      canvas.LineTo(int1*20,400);
      canvas.MoveTo(0,int1*20);
      canvas.LineTo(400,int1*20);
    end;
    for int1 := 0 to 19 do
      for int2 := 0 to 19 do
        if feld[int1,int2]<> 0 then begin
         canvas.FloodFill(int1*20+1,int2*20+1,clWhite,fsSurface);
        end;
    canvas.brush.Style:= bssolid;
    for int1 := 0 to 9 do begin
      if viecher[int1].nahrung > 0 then with viecher[int1] do begin
        canvas.Pen.Width := 3;
        if akt then canvas.pen.color := clBlue else canvas.pen.color := clGray;
        if mark=int1 then canvas.ellipse(rect(posx*20+5,posy*20+5,posx*20+15,posy*20+15));
        canvas.moveto(posx*20+10,posy*20+10);
        case rich of
          0 : canvas.LineTo(posx*20,posy*20+10);
          1 : canvas.LineTo(posx*20+10,posy*20);
          2 : canvas.LineTo(posx*20+20,posy*20+10);
          3 : canvas.LineTo(posx*20+10,posy*20+20);
        end;
      end;
    end;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  createviech;
  updatestatus;
  paintbox1.Repaint;
end;

procedure TForm1.go;
var int1 : integer;
    ranx,rany : integer;
begin
  for int1 := 0 to 9 do with viecher[int1] do if nahrung > 0 then begin
    if akt or (code[ip] = 0) then begin
      akt := true;
      case code[ip] of
        0:;
        1: akt := false;
        2: begin case rich of 0: dec(posx); 1: dec(posy); 2: inc(posx); 3: inc(posy); end; posx := (posx+20) mod 20; posy:= (posy+20) mod 20;end;
        3: rich := (rich + 3) mod 4;
        4: rich := (rich + 1) mod 4;
        5: if feld[posx,posy] = 1 then begin
             feld[posx,posy] := 0;
             inc(nahrung,20);
             repeat
               ranx := random(19);
               rany := random(19);
             until feld[ranx,rany] = 0;
             feld[ranx,rany] := 1;
           end;
        6: begin
             if ip < 98 then begin
               if feld[posx,posy] = 1 then
                 ip := code[ip+1]-1
               else
                 ip := code[ip+2]-1;
             end else die(int1);
               akt := false;
           end;
        7: if nahrung > 45 then begin
             nahrung := nahrung div 2;
             if autook or (mryes = messagedlg('Ein Viech hat eine Generation berlebt !'+#13+'Weiter zchten mit diesem ?',
                           mtinformation,[mbno,mbyes],-1)) then begin
               goodcode := code;
               inc(generation);
             end;
           end;
        8: begin if ip = 100 then die(int1) else ip := code[ip+1]-1; akt := false; end;
//      else die(int1); continue;
      end;
      dec(nahrung);
    end;
    inc(ip);
    if ip > 100 then die(int1);
    if (nahrung > 60) Or (nahrung <= 0) then die(int1);
  end;
end;

function TForm1.testforgood(code_ :TCode; Tests: integer): integer;
var int1,int2, oldg : integer;
    mutant : TCode;
    oldok: boolean;
begin
  oldg := generation;
  mutant := goodcode;
  result := 0;
  oldok := autook;
  autook := true;
  fillchar(viecher,sizeof(viecher),0);
  for int1 := 0 to tests do begin
    generation:= oldg;
    fillchar(viecher[0],sizeof(viecher[0]),0);
    createviech;
    viecher[0].code := code_; // mutiere(code_);
    int2 := 0;
    while (int2 < 1000) and (viecher[0].nahrung > 0) {and (oldg = generation)} do begin
      inc(int2);
      go;
    end;
    inc(result, generation-oldg);
  end;
  autook := oldok;
  goodcode := mutant;
  generation := oldg;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  go;
  paintbox1.repaint;
  updatestatus;
end;

procedure TForm1.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var int1 : integer;
begin
  x := x div 20;
  y := y div 20;
  mark := -1;
  for int1 := 0 to 9 do
    if (viecher[int1].nahrung >0) and (viecher[int1].posx = x) and (viecher[int1].posy = y) then begin
      mark := int1;
    end;
  updatestatus;
  paintbox1.repaint;
end;

procedure TForm1.NeuesViech1Click(Sender: TObject);
begin createviech; end;

procedure TForm1.Hilfe1Click(Sender: TObject);
begin form2.showmodal; end;

procedure TForm1.NeueversucheClick(Sender: TObject);
var int1, int2, anz : integer;
    oldcode : TCode;
begin
  if mrno = messagedlg('Dies lscht alle "gezchteten" Informationen! Wollen Sie weitermachen ?',mtConfirmation,[mbYes,mbNo],-1) then exit;
  waitform.show;
  waitform.modalresult := 0;
  waitform.label5.caption := '0';
  anz := 0;
  autook := true;
  repeat
    fillchar(viecher,sizeof(viecher),0);
    createviech;
    int2 := 0;
    inc(anz);
    for int1 := 0 to 100 do
      goodcode[int1] := random(MaxValue+1);
    oldcode := goodcode;
    repeat go; inc(int2); until (viecher[0].nahrung <= 0) or (int2 > 10000) or (not cmp(goodcode,oldcode));
    if anz mod 10 = 0 then begin
      waitform.label2.caption := inttostr(anz);
      if waitform.modalresult <> 0 then break;
      application.processmessages;
    end;
  until not cmp(oldcode, goodcode);
  generation := 1;
  waitform.close;
  updatestatus;
  paintbox1.repaint;
  filllistbox(listbox2,goodcode);
  autook := false;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin form1.Close; end;

procedure TForm1.Viechladen1Click(Sender: TObject);
var int1 : integer;
begin
  if opendialog1.Execute then begin
    assignfile(viechf,opendialog1.filename);
    reset(viechf);
    readln(viechf,generation);
    for int1 := 0 to 100 do readln(viechf,goodcode[int1]);
    closefile(viechf);
    filllistbox(listbox2,goodcode);
    updatestatus;
  end;
end;

procedure TForm1.Viechspeichern1Click(Sender: TObject);
var int1 : integer;
begin
  if savedialog1.execute then begin
    assignfile(viechf,savedialog1.filename);
    rewrite(viechf);
    writeln(viechf,generation);
    for int1 := 0 to 100 do writeln(viechf,goodcode[int1]);
    closefile(viechf);
  end;
end;

procedure TForm1.EinSchritt1Click(Sender: TObject);
begin go; end;

procedure TForm1.Button3Click(Sender: TObject);
var int1 : integer;
begin
  if mrno = messagedlg('Dies lscht alle "gezchteten" Informationen! Wollen Sie weitermachen?',mtconfirmation,[mbyes,mbno],-1) then exit;
  generation := 0;
  for int1 := 0 to 100 do
    goodcode[int1] := random(MaxValue+1);
  createviech;
  updatestatus;
  filllistbox(listbox2,goodcode);
  paintbox1.Repaint;
end;

procedure TForm1.Zchten1Click(Sender: TObject);
var oldcode      : TCode;
    int2, anz, g : integer;
    oldcodegood  : integer;
    verandert    : boolean;
begin
  form1.Enabled := false;
  autook := true;
  waitform.show;
  waitform.modalresult := 0;
  oldcode := goodcode;
  oldcodegood := testforgood(oldcode,tests);
  anz := 0;
  repeat
    fillchar(viecher,sizeof(viecher),0);
    createviech;
    int2 := 0;
    inc(anz);
    g:= generation;
    repeat
      go;
      inc(int2);
      verandert := g <> generation;
    until (viecher[0].nahrung <= 0) or (int2 > 10000) or verandert;
    if verandert then begin
      dec(generation);
      if testforgood(goodcode,tests) >= oldcodegood+minzerf then begin
        oldcode := goodcode;
        inc(generation);
      end else goodcode := oldcode;
    end;
    if anz mod 10 = 0 then begin
      application.processmessages;
      waitform.label2.caption := inttostr(anz);
      waitform.label5.caption := inttostr(generation);
      if waitform.modalresult <> 0 then break;
    end;
  until 1=2;
  waitform.close;
  updatestatus;
  filllistbox(listbox2,goodcode);
  paintbox1.repaint;
  autook := false;
  form1.Enabled := true;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if mark <> -1 then die(mark);
  paintbox1.repaint;
  updatestatus;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
  label7.Caption := floattostr(testforgood(goodcode,10000)/100)+' Viecher von 100';
end;

procedure TForm1.N0101Click(Sender: TObject);
begin  n0101.Checked := true;  maxValue := 10;end;
procedure TForm1.N0201Click(Sender: TObject);
begin  N0201.Checked := true;  maxValue := 20;end;
procedure TForm1.N01001Click(Sender: TObject);
begin  N01001.Checked := true;  maxValue := 100;end;

procedure TForm1.keine1Click(Sender: TObject);
begin  keine1.Checked := true;  minzerf := 0;end;
procedure TForm1.N101Click(Sender: TObject);
begin  N101.Checked := true;  minzerf := tests div 10;end;
procedure TForm1.N201Click(Sender: TObject);
begin  N201.Checked := true;  minzerf := tests div 5;end;
procedure TForm1.N501Click(Sender: TObject);
begin  N501.Checked:= True; minzerf := tests div 2;end;

procedure TForm1.N11Click(Sender: TObject);
begin N11.Checked := true; AnzMutationen := 1;end;
procedure TForm1.N21Click(Sender: TObject);
begin N21.Checked := true; AnzMutationen := 2;end;
procedure TForm1.N51Click(Sender: TObject);
begin N51.Checked := true; AnzMutationen := 5;end;
procedure TForm1.N102Click(Sender: TObject);
begin N102.Checked := true; AnzMutationen := 10;end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if mark <> -1 then begin
    goodcode := viecher[mark].code;
    filllistbox(listbox2,goodcode);
  end;
end;

end.
